﻿Public Class calendarCalcFunctions
    ' .Net3.5 calendarCalc.  Written by Joe McCormack, 2009. www.virtualsecrets.com
    '
    ' GLOBALS
    '
    Public calendarDateDayOccurance As Integer = 0                      ' From the date given this is how many occurances of the day the date falls on -> 3
    Public calendarDateWeeksInMonth As Integer = 0                      ' From the date given there are this many weeks in month -> 4
    Public calendarDateDaysInMonth As Integer = 0                       ' From the date given there are this many days in month -> 30
    Public calendarDateFirstDayFallsOn As String = String.Empty         ' The first day of the month of date given falls on is -> Monday
    Public calendarDateLastDayFallsOn As String = String.Empty          ' The last day of the month of date given falls on is -> Friday
    Public calendarDateFullDateFallsOnWeek As Integer = 0               ' The week of the month the date falls on is -> 2
    Public calendarDateFullDateFallsOnNumericDay As Integer = 0         ' The day number of the week the date falls on is -> 5
    Public calendarDateFullDateFallsOnNameDay As String = String.Empty  ' The name of the day the date falls on is -> Thursday
    ' Initial calendar data query storage (from calling "calendarDateMonthGetStats()")
    Public prev_calendarDateDayOccurance As Integer = 0
    Public prev_calendarDateWeeksInMonth As Integer = 0
    Public prev_calendarDateDaysInMonth As Integer = 0
    Public prev_calendarDateFirstDayFallsOn As String = String.Empty
    Public prev_calendarDateLastDayFallsOn As String = String.Empty
    Public prev_calendarDateFullDateFallsOnWeek As Integer = 0
    Public prev_calendarDateFullDateFallsOnNumericDay As Integer = 0
    Public prev_calendarDateFullDateFallsOnNameDay As String = String.Empty
    ' Arrays storing consecutive date months and weeks
    Public saveMonthDates() As String
    Public saveWeeklyDates() As String
    '
    ' CALENDAR DATE CALCULATION FUNCTIONS
    '
    Public Sub calendarDateMonthGetStats(ByVal cDay As Integer, ByVal cMonth As Integer, ByVal cYear As Integer)
        ' Calculate various statistics about a start date such as how many weeks are in month, what week of the month date falls into, what day the first of the month is on, what day the last of the month is on, etc.
        Dim startCollection As String = cYear & "," & cMonth & "," & cDay
        ' Get current date info
        Dim dt As New DateTime()
        dt = Convert.ToDateTime(startCollection)
        Dim startMonthNumber As Integer = dt.Month
        Dim startMonthDayName As String = dt.DayOfWeek.ToString()
        Dim startMonthDay As Integer = dt.Day
        Dim startMonthDayNumber As Integer = 0
        Dim startWeekNumber As Integer = 0
        Select Case startMonthDayName.ToLower()
            Case "sunday" : startMonthDayNumber = 1
            Case "monday" : startMonthDayNumber = 2
            Case "tuesday" : startMonthDayNumber = 3
            Case "wednesday" : startMonthDayNumber = 4
            Case "thursday" : startMonthDayNumber = 5
            Case "friday" : startMonthDayNumber = 6
            Case "saturday" : startMonthDayNumber = 7
        End Select
        ' Get info on where first day of month is
        Dim convertMe As String = dt.Year & "," & dt.Month & ",1"
        Dim dtCheck As New DateTime()
        dtCheck = Convert.ToDateTime(convertMe)
        Dim dtStartMonthDayNumber As Integer = Weekday(dtCheck)
        Dim dtStartMonthDayName As String = Nothing
        Select Case dtStartMonthDayNumber
            Case 1 : dtStartMonthDayName = "Sunday"
            Case 2 : dtStartMonthDayName = "Monday"
            Case 3 : dtStartMonthDayName = "Tuesday"
            Case 4 : dtStartMonthDayName = "Wednesday"
            Case 5 : dtStartMonthDayName = "Thursday"
            Case 6 : dtStartMonthDayName = "Friday"
            Case 7 : dtStartMonthDayName = "Saturday"
        End Select
        ' Get info on where last day of month is
        Dim dtNumberOfDays As Integer = 0
        Select Case dt.Month
            Case 1, 3, 5, 7, 8, 10, 12
                dtNumberOfDays = 31
            Case 2
                ' Should only need year, but that's not the case.
                convertMe = dt.Year & "," & dt.Month & ",1"
                If (Year(Convert.ToDateTime(convertMe)) Mod 4) = 0 Then
                    dtNumberOfDays = 29
                Else
                    dtNumberOfDays = 28
                End If
            Case 4, 6, 9, 11
                dtNumberOfDays = 30
        End Select
        convertMe = dt.Year & "," & dt.Month & "," & dtNumberOfDays
        Dim dtCheck2 As New DateTime()
        dtCheck2 = Convert.ToDateTime(convertMe)
        Dim dtEndMonthDayNumber As Integer = Weekday(dtCheck2)
        Dim dtEndMonthDayName As String = Nothing
        Dim dtEndWeekNumber As Integer = 0
        Select Case dtEndMonthDayNumber
            Case 1 : dtEndMonthDayName = "Sunday"
            Case 2 : dtEndMonthDayName = "Monday"
            Case 3 : dtEndMonthDayName = "Tuesday"
            Case 4 : dtEndMonthDayName = "Wednesday"
            Case 5 : dtEndMonthDayName = "Thursday"
            Case 6 : dtEndMonthDayName = "Friday"
            Case 7 : dtEndMonthDayName = "Saturday"
        End Select
        ' Get number of weeks in month
        Dim dtWeeksInMonth As Integer = 0
        If dtNumberOfDays = 28 Then
            Select Case dtStartMonthDayNumber
                Case 1 : dtWeeksInMonth = 4
                Case 2 : dtWeeksInMonth = 5
                Case 3 : dtWeeksInMonth = 5
                Case 4 : dtWeeksInMonth = 5
                Case 5 : dtWeeksInMonth = 5
                Case 6 : dtWeeksInMonth = 5
                Case 7 : dtWeeksInMonth = 5
            End Select
        ElseIf dtNumberOfDays = 29 Then
            Select Case dtStartMonthDayNumber
                Case 1 : dtWeeksInMonth = 5
                Case 2 : dtWeeksInMonth = 5
                Case 3 : dtWeeksInMonth = 5
                Case 4 : dtWeeksInMonth = 5
                Case 5 : dtWeeksInMonth = 5
                Case 6 : dtWeeksInMonth = 5
                Case 7 : dtWeeksInMonth = 5
            End Select
        ElseIf dtNumberOfDays = 30 Then
            Select Case dtStartMonthDayNumber
                Case 1 : dtWeeksInMonth = 5
                Case 2 : dtWeeksInMonth = 5
                Case 3 : dtWeeksInMonth = 5
                Case 4 : dtWeeksInMonth = 5
                Case 5 : dtWeeksInMonth = 5
                Case 6 : dtWeeksInMonth = 5
                Case 7 : dtWeeksInMonth = 6
            End Select
        ElseIf dtNumberOfDays = 31 Then
            Select Case dtStartMonthDayNumber
                Case 1 : dtWeeksInMonth = 5
                Case 2 : dtWeeksInMonth = 5
                Case 3 : dtWeeksInMonth = 5
                Case 4 : dtWeeksInMonth = 5
                Case 5 : dtWeeksInMonth = 5
                Case 6 : dtWeeksInMonth = 6
                Case 7 : dtWeeksInMonth = 6
            End Select
        End If
        dtEndWeekNumber = dtWeeksInMonth
        ' Determine start date week
        Dim theDay As Integer = 1
        Dim dayCount As Integer = 1
        Dim hasTriggered As Integer = 0
        Dim theDayPhrase = "Sunday"
        Dim dayOfWeekCount() As Integer = {0, 0, 0, 0, 0, 0, 0}
        Dim dayOfWeekDayCount As Integer = 0
        For x As Integer = 1 To dtWeeksInMonth
            For y As Integer = 1 To 7
                Select Case theDay
                    Case 1 : theDayPhrase = "Sunday"
                    Case 2 : theDayPhrase = "Monday"
                    Case 3 : theDayPhrase = "Tuesday"
                    Case 4 : theDayPhrase = "Wednesday"
                    Case 5 : theDayPhrase = "Thursday"
                    Case 6 : theDayPhrase = "Friday"
                    Case 7 : theDayPhrase = "Saturday"
                End Select
                If x = 1 Then
                    ' Week One
                    If theDayPhrase.ToLower() = dtStartMonthDayName.ToLower() Then
                        If hasTriggered = 0 Then
                            ' This is the first day of the month
                            hasTriggered = 1
                        Else
                            ' This is another day of the month
                        End If
                        If startMonthDay = dayCount Then
                            startWeekNumber = x
                        End If
                        If hasTriggered = 1 Then
                            dayOfWeekCount(theDay - 1) = dayOfWeekCount(theDay - 1) + 1
                            If dayCount = startMonthDay Then
                                dayOfWeekDayCount = dayOfWeekCount(theDay - 1)
                            End If
                        End If
                        dayCount = dayCount + 1
                    Else
                        If hasTriggered = 1 Then
                            ' This is another day of the month
                            If startMonthDay = dayCount Then
                                startWeekNumber = x
                            End If
                            dayOfWeekCount(theDay - 1) = dayOfWeekCount(theDay - 1) + 1
                            If dayCount = startMonthDay Then
                                dayOfWeekDayCount = dayOfWeekCount(theDay - 1)
                            End If
                            dayCount = dayCount + 1
                        Else
                            ' Do not count these days before the first day of the month
                        End If
                    End If
                Else
                    ' Other Week
                    If dayCount > dtNumberOfDays Then
                        ' Do not count these days after the end of the month
                    Else
                        If startMonthDay = dayCount Then
                            startWeekNumber = x
                        End If
                        dayOfWeekCount(theDay - 1) = dayOfWeekCount(theDay - 1) + 1
                        If dayCount = startMonthDay Then
                            dayOfWeekDayCount = dayOfWeekCount(theDay - 1)
                        End If
                        dayCount = dayCount + 1
                    End If
                End If
                theDay = theDay + 1
            Next
            theDay = 1
        Next
        ' Assign to globals
        calendarDateDayOccurance = dayOfWeekDayCount
        calendarDateWeeksInMonth = dtWeeksInMonth
        calendarDateDaysInMonth = dtNumberOfDays
        calendarDateFirstDayFallsOn = dtStartMonthDayName
        calendarDateLastDayFallsOn = dtEndMonthDayName
        calendarDateFullDateFallsOnWeek = startWeekNumber
        calendarDateFullDateFallsOnNumericDay = startMonthDayNumber
        calendarDateFullDateFallsOnNameDay = startMonthDayName
    End Sub
    Public Sub calendarDateMonthStatsSave()
        ' Retain values obtained by subroutine "calendarDateMonthGetStats()"
        prev_calendarDateDayOccurance = calendarDateDayOccurance
        prev_calendarDateWeeksInMonth = calendarDateWeeksInMonth
        prev_calendarDateDaysInMonth = calendarDateDaysInMonth
        prev_calendarDateFirstDayFallsOn = calendarDateFirstDayFallsOn
        prev_calendarDateLastDayFallsOn = calendarDateLastDayFallsOn
        prev_calendarDateFullDateFallsOnWeek = calendarDateFullDateFallsOnWeek
        prev_calendarDateFullDateFallsOnNumericDay = calendarDateFullDateFallsOnNumericDay
        prev_calendarDateFullDateFallsOnNameDay = calendarDateFullDateFallsOnNameDay
    End Sub
    Public Sub calendarDateMonthStatsConsecutiveMonths(ByVal startYr As Integer, ByVal startMo As Integer, ByVal nMons As Integer)
        ' Calculates matching consecutive months from a start date
        Dim dt2 As New DateTime() : dt2 = Convert.ToDateTime(startYr & "," & startMo & ",1")
        Dim saveDatesCount As Integer = 0
        For nMonths As Integer = 1 To nMons
            ' Set next month
            dt2 = dt2.AddMonths(1)
            ' Get calendar data for next month
            Dim dtDay_HoldMe As Integer = 1
            Dim dtMonth_HoldMe As Integer = Convert.ToInt32(dt2.Month.ToString())
            Dim dtYear_HoldMe As Integer = Convert.ToInt32(dt2.Year.ToString())
            calendarDateMonthGetStats(dtDay_HoldMe, dtMonth_HoldMe, dtYear_HoldMe)
            ' Go through next calendar month
            Dim theDay As Integer = 1
            Dim dayCount As Integer = 1
            Dim hasTriggered As Integer = 0
            Dim hasSavedMonth As Integer = 0
            Dim theDayPhrase = "Sunday"
            Dim dayOfWeekCount() As Integer = {0, 0, 0, 0, 0, 0, 0}
            For X As Integer = 1 To calendarDateWeeksInMonth Step 1
                For y As Integer = 1 To 7 Step 1
                    Select Case theDay
                        Case 1 : theDayPhrase = "Sunday"
                        Case 2 : theDayPhrase = "Monday"
                        Case 3 : theDayPhrase = "Tuesday"
                        Case 4 : theDayPhrase = "Wednesday"
                        Case 5 : theDayPhrase = "Thursday"
                        Case 6 : theDayPhrase = "Friday"
                        Case 7 : theDayPhrase = "Saturday"
                    End Select
                    If X = 1 Then
                        If theDayPhrase.ToLower() = calendarDateFullDateFallsOnNameDay.ToLower() Then
                            hasTriggered = 1
                        End If
                    End If
                    If hasTriggered = 1 And hasSavedMonth = 0 Then
                        dayOfWeekCount(theDay - 1) = dayOfWeekCount(theDay - 1) + 1
                        If theDayPhrase.ToLower() = prev_calendarDateFullDateFallsOnNameDay.ToLower() Then
                            Dim performSave As Integer = 0
                            If prev_calendarDateDayOccurance > 4 Then
                                If (dayCount + 7) > calendarDateDaysInMonth Then
                                    performSave = 1
                                End If
                            Else
                                If dayOfWeekCount(theDay - 1) = prev_calendarDateDayOccurance Then
                                    performSave = 1
                                End If
                            End If
                            If performSave = 1 And hasSavedMonth = 0 Then
                                ReDim Preserve saveMonthDates(saveDatesCount) : saveMonthDates(saveDatesCount) = dtMonth_HoldMe & "/" & dayCount & "/" & dtYear_HoldMe
                                saveDatesCount = saveDatesCount + 1
                                hasSavedMonth = 1
                            End If
                        End If
                    End If
                    If hasTriggered = 1 Then : dayCount = dayCount + 1 : End If
                    theDay = theDay + 1
                Next
                theDay = 1
            Next
        Next
    End Sub
    Public Sub calendarDateWeeklyStatsConsecutiveWeeks(ByVal cDay As Integer, ByVal cMonth As Integer, ByVal cYear As Integer, ByVal nWeeks As Integer)
        ' Calculates the consecutive weekly dates from a start date
        Dim startCollection As String = cYear & "," & cMonth & "," & cDay
        Dim saveWeeklyDatesCount As Integer = 0
        Dim dayCount As Integer = 7
        Dim dt As New DateTime()
        dt = Convert.ToDateTime(startCollection)
        For mn As Integer = 1 To nWeeks
            dt = dt.AddDays(dayCount)
            ReDim Preserve saveWeeklyDates(saveWeeklyDatesCount) : saveWeeklyDates(saveWeeklyDatesCount) = dt.Month & "/" & dt.Day & "/" & dt.Year
            saveWeeklyDatesCount = saveWeeklyDatesCount + 1
        Next
    End Sub
End Class
